<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.1"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Lifinity Dungeon: cpp_filrouge_iscj_allemann/include/Game.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Lifinity Dungeon
   &#160;<span id="projectnumber">6</span>
   </div>
   <div id="projectbrief">The Lifinity Dungeon is a dungeon with an infinity of room. After each room, you found a harder room. This is why you will pass the eternity of your life in this dungeon</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.1 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_7b4dd9274471389300495e9c763ca813.html">cpp_filrouge_iscj_allemann</a></li><li class="navelem"><a class="el" href="dir_e5b3fe71963387781ba01d2a56ee1874.html">include</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">Game.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_game_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160; </div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="preprocessor">#pragma once</span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160; </div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="preprocessor">#include &lt;iostream&gt;</span></div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="preprocessor">#include &lt;memory&gt;</span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="preprocessor">#include &lt;tuple&gt;</span></div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160; </div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_character_class_8hpp.html">./Character/CharacterClass.hpp</a>&quot;</span></div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_room_8hpp.html">./Room/Room.hpp</a>&quot;</span></div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_lane_8hpp.html">./Room/Lane.hpp</a>&quot;</span></div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_log_8hpp.html">./Log/Log.hpp</a>&quot;</span></div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_i_spell_8hpp.html">./Spell/ISpell.hpp</a>&quot;</span></div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160; </div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;<span class="keyword">using namespace </span>std;</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160; </div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="keyword">namespace </span>He_Arc::RPG</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;{</div>
<div class="line"><a name="l00041"></a><span class="lineno"><a class="line" href="class_he___arc_1_1_r_p_g_1_1_game.html">   41</a></span>&#160;    <span class="keyword">class </span><a class="code" href="class_he___arc_1_1_r_p_g_1_1_game.html">Game</a></div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    {</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;    <span class="keyword">private</span>:</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;        <span class="keywordtype">int</span> m_nbAlly{4};</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;        <span class="keywordtype">int</span> m_gameLevel{0};</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160; </div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;        unique_ptr&lt;Room&gt; m_fightingRoom;</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;        vector&lt;shared_ptr&lt;CharacterClass&gt;&gt; m_playerTeam;</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;        vector&lt;shared_ptr&lt;CharacterClass&gt;&gt; m_ennemyTeam;</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160; </div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;        vector&lt;shared_ptr&lt;CharacterClass&gt;&gt; m_fightOrder;</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160; </div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;        <span class="keywordtype">void</span> CreateEnnemyTeamComposition();</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;        <span class="keywordtype">void</span> SetTurnOrder();</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;        <span class="keywordtype">void</span> GetNextPlayer();</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160; </div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;        <span class="keywordtype">void</span> DoPlayerCharacterTurn();</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160; </div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;        <span class="keywordtype">void</span> DoEnnemyCharacterTurn();</div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160; </div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;        <span class="comment">// ENNEMY ACTION</span></div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;<span class="comment"></span>        <span class="keywordtype">int</span> DoEnnemyTurnGetMaxRange();</div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;        tuple&lt;bool, vector&lt;shared_ptr&lt;ISpell&gt;&gt;&gt; DoEnnemyTurnGetPossibleSpell(<span class="keywordtype">int</span> range);</div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;        tuple&lt;bool, shared_ptr&lt;ISpell&gt;&gt; DoEnnemyTurnGetRandomSpell(<span class="keywordtype">bool</span> includeObject, vector&lt;shared_ptr&lt;ISpell&gt;&gt; possibleSpells);</div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;        vector&lt;shared_ptr&lt;CharacterClass&gt;&gt; DoEnnemyTurnGetPossibleTarget(<span class="keywordtype">int</span> range);</div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;        shared_ptr&lt;CharacterClass&gt; DoEnnemyTurnGetRandomTarget(vector&lt;shared_ptr&lt;CharacterClass&gt;&gt; possibleTargets);</div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;        <span class="keywordtype">void</span> DoEnnemyTurnUseSpell(<span class="keywordtype">bool</span> useObject, shared_ptr&lt;ISpell&gt; spell, shared_ptr&lt;CharacterClass&gt; target);</div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;        <span class="keywordtype">void</span> DoEnnemyTurnMoveLeft();</div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160; </div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;        <span class="comment">// MENU ACTION</span></div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;<span class="comment"></span>        <span class="keywordtype">void</span> DoActionMenuPass();</div>
<div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;        <span class="keywordtype">bool</span> DoActionMenuMove();</div>
<div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;        <span class="keywordtype">bool</span> DoActionMenuFight();</div>
<div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;        tuple&lt;bool, bool, shared_ptr&lt;ISpell&gt;&gt; DoActionMenuFightSelectSpell();</div>
<div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160; </div>
<div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;        tuple&lt;bool, shared_ptr&lt;CharacterClass&gt;&gt; DoActionMenuFightSelectTarget(<span class="keywordtype">int</span> range);</div>
<div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160; </div>
<div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;        <span class="keywordtype">bool</span> MoveDeadCharacters();</div>
<div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160; </div>
<div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;    <span class="keyword">public</span>:</div>
<div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;        <a class="code" href="class_he___arc_1_1_r_p_g_1_1_game.html">Game</a>(<span class="keywordtype">int</span> nbAlly = 4);</div>
<div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;        <a class="code" href="class_he___arc_1_1_r_p_g_1_1_game.html">Game</a>(<span class="keyword">const</span> <a class="code" href="class_he___arc_1_1_r_p_g_1_1_game.html">Game</a> &amp;game);</div>
<div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;        <span class="keyword">virtual</span> ~<a class="code" href="class_he___arc_1_1_r_p_g_1_1_game.html">Game</a>() = <span class="keywordflow">default</span>;</div>
<div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;        <span class="keywordtype">int</span> GetGameLevel();</div>
<div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;        <a class="code" href="class_he___arc_1_1_r_p_g_1_1_game.html">Game</a> &amp;operator=(<span class="keyword">const</span> <a class="code" href="class_he___arc_1_1_r_p_g_1_1_game.html">Game</a> &amp;game);</div>
<div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160; </div>
<div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;        <span class="keywordtype">void</span> CreateTeamComposition();</div>
<div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160; </div>
<div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;        <span class="keywordtype">void</span> EnterFightingRoom();</div>
<div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;        <span class="keywordtype">void</span> DisplayFight() <span class="keyword">const</span>;</div>
<div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;        <span class="keywordtype">void</span> PerformGameTurn();</div>
<div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;        <a class="code" href="_enums_8hpp.html#ad46aac46ff35875d2e579285bc6289b9">TeamGrp</a> ThereIsDeadTeam();</div>
<div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;        <span class="keywordtype">bool</span> IsDeadTeam(vector&lt;shared_ptr&lt;CharacterClass&gt;&gt; team);</div>
<div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160; </div>
<div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;        <span class="keywordtype">void</span> IncreaseGameLevel();</div>
<div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160; </div>
<div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160;        <span class="keywordtype">void</span> PerformStartRoom();</div>
<div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160; </div>
<div class="line"><a name="l00288"></a><span class="lineno">  288</span>&#160;        <span class="keywordtype">void</span> HealPlayer(<span class="keywordtype">int</span> amount);</div>
<div class="line"><a name="l00289"></a><span class="lineno">  289</span>&#160;    };</div>
<div class="line"><a name="l00290"></a><span class="lineno">  290</span>&#160;} <span class="comment">// namespace He_Arc::RPG</span></div>
<div class="ttc" id="a_character_class_8hpp_html"><div class="ttname"><a href="_character_class_8hpp.html">CharacterClass.hpp</a></div><div class="ttdoc">: Header file, for the class &quot;CharacterClass.cpp&quot;</div></div>
<div class="ttc" id="a_enums_8hpp_html_ad46aac46ff35875d2e579285bc6289b9"><div class="ttname"><a href="_enums_8hpp.html#ad46aac46ff35875d2e579285bc6289b9">He_Arc::RPG::TeamGrp</a></div><div class="ttdeci">TeamGrp</div><div class="ttdoc">The type of groups of characters.</div><div class="ttdef"><b>Definition:</b> Enums.hpp:32</div></div>
<div class="ttc" id="a_i_spell_8hpp_html"><div class="ttname"><a href="_i_spell_8hpp.html">ISpell.hpp</a></div><div class="ttdoc">: Interface class, for the different spells/skills who can be rise by characters</div></div>
<div class="ttc" id="a_lane_8hpp_html"><div class="ttname"><a href="_lane_8hpp.html">Lane.hpp</a></div><div class="ttdoc">: Header file, for the class &quot;Lane.cpp&quot;</div></div>
<div class="ttc" id="a_log_8hpp_html"><div class="ttname"><a href="_log_8hpp.html">Log.hpp</a></div><div class="ttdoc">: Header file, for the class &quot;Log.cpp&quot;</div></div>
<div class="ttc" id="a_room_8hpp_html"><div class="ttname"><a href="_room_8hpp.html">Room.hpp</a></div><div class="ttdoc">: Header file, for the class &quot;Room.cpp&quot;</div></div>
<div class="ttc" id="aclass_he___arc_1_1_r_p_g_1_1_game_html"><div class="ttname"><a href="class_he___arc_1_1_r_p_g_1_1_game.html">He_Arc::RPG::Game</a></div><div class="ttdoc">This class is the game logic implementation, It regroups each classes and interconnect them to perfor...</div><div class="ttdef"><b>Definition:</b> Game.hpp:42</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.1
</small></address>
</body>
</html>
